
#include <fstream>
#include <iostream>
#include <gd.h>
#include <fltk/events.h>
#include <fltk/visual.h>
#include <fltk/draw.h>
#include <fltk/SharedImage.h>
#include "BaseStationWindow.h"

using namespace std;

// this is what I need to use libtiff
#include <stdio.h>
#include <tiffio.h>
// this routine reads in a tiff file and stores it in a very simple data structure
int readTiff(char* filename, int& rw, int& rh, unsigned char * &rbits)
{
  // we turn off Warnings (maybe a bad idea) since many photoshop images
  // have newfangled tags that confuse libtiff
  TIFFErrorHandler warn = TIFFSetWarningHandler(0);

  TIFF* tiff = TIFFOpen(filename, "r");

  // turn warnings back on, just in case
  TIFFSetWarningHandler(warn);

  if (tiff) {
    int rc = 1;			// what to return
    uint32 w, h;
    size_t npixels;
    uint32* raster;

    TIFFGetField(tiff, TIFFTAG_IMAGEWIDTH, &w);
    TIFFGetField(tiff, TIFFTAG_IMAGELENGTH, &h);

    // in case my data structures are different
    rw = w;
    rh = h;

    npixels = w * h;
    raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32));
    if (raster != NULL) {
      if (TIFFReadRGBAImage(tiff, w, h, raster, 0)) {
	rbits = (unsigned char*) raster;
      } else {
	rc=0;
	_TIFFfree(raster);
      }
    } else rc = 0;

    TIFFClose(tiff);
    return rc;
  } else
    return 0;
}

ImgView::ImgView(int x,int y,int w,int h,const char* l)
    : fltk::Widget(x,y,w,h,l)
{
    fltk::register_images();
    strcpy(imageName,"");
    image = NULL;
}

ImgView::~ImgView()
{
}

void ImgView::draw()
{
    img->reload();
    fltk::Widget::draw();
}

//void ImgView::draw() : fltk::Widget::draw()
//{
    //unsigned char* imageBottom = image + w * 4 * (h-1);
    //fltk::drawimage(imageBottom,5,5,w,h,4,-w*4);
    //fltk::drawimage(imageBottom,fltk::RGB32,fltk::Rectangle(5,5,w,h),-w*4);
    //fltk::drawimage(image+(120*8),fltk::RGB32,fltk::Rectangle(w,h),161 * 8);
    //fltk::drawimage(image+(120*8),fltk::RGB32,fltk::Rectangle(w,h),w*8);
    
    //img->draw(1,1);
    //fltk::drawimage(img->buffer(),fltk::RGB32,fltk::Rectangle(0,0,w,h),img->buffer_linedelta());
//}

void ImgView::loadImage(char* s)
{
    strcpy(imageName,s);
    img = fltk::SharedImage::get(s);
    
    fltk::Widget::image(img);
}

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

BaseStationWindow::BaseStationWindow(int x,int y,int w,int h,const char* l)
    : fltk::Window(x,y,w,h,l)
{
}

BaseStationWindow::BaseStationWindow(int x,int y,const char* l)
    : fltk::Window(x,y,l)
{
}

int BaseStationWindow::handle(int ev)
{
    switch (ev)
    {
        case fltk::KEY:
            //cout << fltk::event_key() << endl;
        return 1;
    }
    return fltk::Window::handle(ev);
}
