#include <iostream>
#include <signal.h>
#include <pthread.h>
#include <SDL/SDL.h>
#include <fltk/run.h>

#include "BaseStation.h"
//#include "ThisRobot.h"

using namespace std;

BaseStation*    base;

void GetOdometry(TOdo& odometry)
{
    base->slam->GetOdometry(odometry);
}

void GetSensation(TSense& sense)
{
    base->slam->GetSensation(sense);
}

void sigcb(int i)
{
    cout << "SIGNAL!" << endl;
    switch (i)
    {
        case SIGINT:
        case SIGQUIT:
        case SIGSEGV:
        case SIGABRT:
        case SIGILL:
        case SIGBUS:
        case SIGFPE:
        case SIGTERM:
        default:
            base->Stop();
        break;
    }

    signal(i,SIG_DFL);
    raise(i);
}

int main(int argc,char** argv)
{
    PLAYBACK = "";
    signal(SIGINT,sigcb);
    signal(SIGQUIT,sigcb);
    signal(SIGSEGV,sigcb);
    signal(SIGABRT,sigcb);
    signal(SIGILL,sigcb);
    signal(SIGBUS,sigcb);
    signal(SIGFPE,sigcb);
    signal(SIGTERM,sigcb);

    fltk::lock();

    base = new BaseStation;
    base->Start();
    BaseStationGUI* gui = new BaseStationGUI(base);
    gui->Start();

    return fltk::run();
}

/*
class BaseApp : public Thread
{
    BaseStationGUI* gui;
    Mutex imgMutex;

    Connection* listenC;

public:
    BaseApp() {}

    virtual void Setup()
    {
#ifdef NO_USAR
        listenC = new Connection;
        listenC->fdl = tcp_listen("5555");
        listenC->con = tcp_accept(listenC->fdl);
#else
        listenC = new Connection("169.236.152.213","5874","base","7778","169.236.152.233");
        //sendC   = new Connection("169.236.152.213","5874","base","7779","169.236.152.233");
#endif
        //listenC->Start();
        cout << "BaseApp::Setup" << endl;
    }
    virtual void Execute()
    {
        cout << "BaseApp::Execute" << endl;
        while (1)
        {
            cout << "+";
            Packet p;
            //listenC->getNextPacket(&p);
        }
    }
};
*/
/*

void* sendCmds(void* arg)
{
    Connection* c = (Connection *)arg;

    if (!c->connect("talon1","7781"))
    {
        cout << "not connected" << endl;
        return NULL;
    }
    SDL_Joystick* joy;
    if (SDL_Init(SDL_INIT_JOYSTICK) < 0)
        return NULL;

    int counter = 0;
    if (SDL_NumJoysticks() > 0)
    {
        bool bDone = false;
        joy = SDL_JoystickOpen(1);
        if (joy)
        {

            for (int i=0;i<1500;i++)
                SDL_JoystickUpdate();
            usleep(500000);

            while (!bDone)
            {
                SDL_JoystickUpdate();
                for (int i=0;i<SDL_JoystickNumButtons(joy);i++)
                {
                    if (SDL_JoystickGetButton(joy,i)==1)
                    {
                        char z[64];
                        sprintf(z,"hihi! #%i",counter++);
                        Packet p(CMD,strlen(z)+1,z);
                        c->send(p);
                        sleep(1);
                        cout << "Button " << i << " " << endl;
                        if (i==7)
                        {
                            c->close(true);
                            bDone = true;
                        }
                    }
                }
            }
        }
    }
    c->close(true);
    return NULL;
}

void* listenForImgs(void* arg)
{
    Connection* c = (Connection *)arg;
#ifdef NO_USAR
    c->fdl = tcp_listen("5555");
    c->con = tcp_accept(c->fdl);
#else
    if (!c->listen())
    {
        cout << "not listening" << endl;
        return NULL;
    }
#endif
    
    Packet* p;
    int counter = 0;

    while (1)
    {
        p = c->recv();
        if (p==NULL)
        //    continue;
            break;

        if (p->type==IMG)
        {
            imgMutex.lock();
#ifdef NO_USAR
            FILE* f = fopen("img.jpg","wb");
#else
            FILE* f = fopen("img.jpg","wb");
            //char z[64];
            //sprintf(z,"img%i.jpg",counter);
            //FILE* f = fopen(z,"wb");
#endif
            gdImagePtr img = gdImageCreateFromJpegPtr(p->size,p->data);
            if (img)
            {
                gdImageJpeg(img,f,50);
                gdImageDestroy(img);
                cout << "Img # "<< counter++ << " Sucessfully grabbed image from talon!" << endl;
            }
            else
            {
                fclose(f);
                f = fopen("img.dump","wb");
                fwrite(p->data,1,p->size,f);
            }
            fclose(f);
            imgMutex.unlock();
        }
        delete p;
    }
    
    return NULL;
}

Window* w;

void refresh(void* args)
{
    lock();

    imgMutex.lock();
    
    cout << "refresh" << endl;
    gui->redraw();

    imgMutex.unlock();

    repeat_timeout(1.0f,refresh);
    unlock();
}
*/

/*
int main(int argc,char** argv)
{
    pthread_t sendThread;
    pthread_t listenThread;

        // This must be called here in order to use threads and fltk!
    lock();
#ifdef NO_USAR
    Connection* listenC = new Connection;
    Connection* sendC = new Connection;
#else
    Connection* listenC = new Connection("169.236.152.213","5874","base","7778","169.236.152.233");
    Connection* sendC   = new Connection("169.236.152.213","5874","base","7779","169.236.152.233");
#endif
    
    //pthread_create(&sendThread,NULL,sendCmds,(void* )sendC);
    pthread_create(&listenThread,NULL,listenForImgs,(void* )listenC);

    add_timeout(1.0f,refresh);

    gui = new BaseStationGUI();
    gui->Start();
    int ret = run();

    //pthread_join(sendThread,NULL);
    pthread_join(listenThread,NULL);

#ifdef NO_USAR
    tcp_close(listenC->fdl);
    tcp_close(listenC->con);
    tcp_close(sendC->fdl);
    tcp_close(sendC->con);
#else
    listenC->close();
    sendC->close(true);
#endif

    return ret;
}
*/
