#ifndef __MAPPER_H__
#define __MAPPER_H__

#include <deque>
#include "Thread.h"

class Mapper : public Thread
{
    SignalMutex gridMutex;
    float* grid;
    bool bFirstScan;
    float initialOdo[3];
    int width,height;
    std::deque<char*> Q;
public:
    Mapper();
    ~Mapper();

    void push(char* sData);
    void processString(char* sData);
    void updateGridSquare(int x,int y,float value);
        // Borrowed from DPSLAM and modified.
    void addRay(float startx,float starty,float MeasuredDist,float theta,int addEnd);
    void updateOccupancyGrid(float* odo,float* sense);

    bool exportTif(char* sFilename);

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif
