#ifndef __BASESTATION_H__
#define __BASESTATION_H__

#include "Thread.h"
#include "BaseStationGUI.h"
#include "ConnectionManager.h"
#include "JoystickManager.h"
#include "Slam.h"

class BaseStation : public Thread
{
    bool bOK,bStarted;
    ConnectionManager* connectionManager;
    JoystickManager* joystickManager;
    BaseStationGUI* gui;

public:
    Slam* slam;
    SignalMutex imgMutex;
    SignalMutex logMutex;
    
    BaseStation();
    void setGUI(BaseStationGUI* pGUI) { gui = pGUI; }
    void start();

    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif
