// generated by Fast Light User Interface Designer (fluid) version 2.1000

#ifndef BaseStationGUI_h
#define BaseStationGUI_h
#include <iostream>
#include <gd.h>
#include <fltk/run.h>
#include <fltk/math.h>
#include <fltk/Widget.h>
#include <fltk/draw.h>
#include <fltk/visual.h>
#include <fltk/SharedImage.h>
class BaseStation;
class BaseStationGUI;
#include "BaseStation.h"
#include "Thread.h"
int readTiff(char* filename,int& rw,int& rh,unsigned char* &rbits);
void timecb(void* v);

class ScanView : public fltk::Widget  {
	float ranges[181];
public:
	ScanView(int x,int y,int w,int h,const char* l) ;
	virtual void draw();
	void pushLaserRanges(float* pRanges);
};

class MapView : public fltk::Widget  {
public:
	float currX,currY,currTheta;
private:
	fltk::Image* img;
public:
	int iw,ih;
private:
	char filename[64];
public:
	float scale,upperLeftX,upperLeftY;
	MapView(int x,int y,int w,int h,const char* l) ;
	virtual void draw();
	void reload();
	void setFilename(char* s);
	virtual int handle(int ev);
	void loadTFW(char* s);
};

class CameraView : public fltk::Widget  {
	fltk::SharedImage* img;
public:
	CameraView(int x,int y,int w,int h,const char* l) ;
	virtual void draw();
	virtual int handle(int ev);
};
#include <fltk/Window.h>
#include <fltk/ValueOutput.h>
#include <fltk/TabGroup.h>
#include <fltk/Group.h>
#include <fltk/Button.h>
#include <fltk/ProgressBar.h>
#include <fltk/Output.h>
#include <fltk/ValueInput.h>

class BaseStationGUI : public Thread  {
	char sImgFilename[64];
public:
	BaseStationGUI(BaseStation* b);
	virtual void Start();
	fltk::Window *win;
		CameraView *cameraView;
		MapView *mapView;
		MapView *aprioriView;
		ScanView *scanView;
		fltk::ValueOutput *oxOutput;
		fltk::ValueOutput *xp;
		fltk::ValueOutput *yp;
private:
				inline void cb_Quit_i(fltk::Button*, void*);
				static void cb_Quit(fltk::Button*, void*);
				inline void cb_Screenshot_i(fltk::Button*, void*);
				static void cb_Screenshot(fltk::Button*, void*);
public:
				fltk::Button *bStart;
private:
				inline void cb_bStart_i(fltk::Button*, void*);
				static void cb_bStart(fltk::Button*, void*);
public:
				fltk::ProgressBar *signalStrength;
				fltk::Output *vFileLine;
		fltk::ValueOutput *othetaOutput;
		fltk::ValueOutput *oyOutput;
		fltk::ValueInput *geoxInput;
		fltk::ValueInput *geoyInput;
		fltk::ValueInput *geothetaInput;
	virtual void Execute();
	virtual void Exit();
	void Stop();
	void redraw();
	void pushOdoPoint(float ox,float oy,float otheta);
};
#endif
