#ifndef __CONNECTION_H__
#define __CONNECTION_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "Thread.h"
#include "Packet.h"

void itoa(int i,char *s);
int tcp_connect(char* host,char* port);
int tcp_close(int fd);
int tcp_listen(char* port);
int tcp_accept(int listen);
    
class Connection
{
    char utHost[32];
    char utPort[8];
    char hBot[32];
    char hPort[8];
    char hIP[32];
    int excessBytes,excessMax;
    char* excess;
    int state;

    Mutex packetMutex;
    Packet* p;

public:
    int fdc,fdl,con;

    Connection() { }
    Connection(char* utServerIP,char* utListenPort,char* bot,char* port,char* ip="localhost");
    bool getOK(int fd);
    float getSS(char* bot);

    bool connectNoUT(char* port);
    bool listenNoUT();
    bool registerBot(char* botIP);
    bool listen();
    bool connect(char* bot,char* port);
    bool send(Packet* p,bool bForUS=true);
    Packet* recv();
    void close(bool bSendClose=false);
};

#endif
