#ifndef __PROXYMANAGER_H__
#define __PROXYMANAGER_H__

#include <playerclient.h>
#include "Packet.h"
#include "ConnectionManager.h"
#include "Thread.h"

class ProxyManager : public Thread
{
    PlayerClient* pc;
    PositionProxy* pp;
    LaserProxy* lp;
    ActArrayProxy* aap;

    float lastX,lastY,lastTheta;
    float speed,rot;
    int currLink;
    float linkSpeeds[PLAYER_ACTARRAY_NUM_ACTUATORS];
    Packet* p;
    int rate,dataCount;

    SignalMutex readMutex;
    SignalMutex writeMutex;
public:
    ProxyManager(char* pIP,char* pPort);
    
    void move(float s,float r,int numLinks,float* lSpeeds);
    Packet* front(); 
    void pop_front(); 
    
    virtual void Setup();
    virtual void Execute();
    virtual void Exit();
};

#endif
