// generated by Fast Light User Interface Designer (fluid) version 2.1000

#include "BaseStationGUI.h"
#include <tiffio.h>
#include <fltk/events.h>
static int currVictimID=0;
static BaseStation* base = NULL;
static fltk::ValueOutput* xpos=NULL;
static fltk::ValueOutput* ypos=NULL;
static fltk::Button* buttonStart = NULL;
static fltk::Output* victimFileLine;

int readTiff(char* filename,int& rw,int& rh,unsigned char* &rbits) {
	// we turn off Warnings (maybe a bad idea) since many photoshop images
	  // have newfangled tags that confuse libtiff
	  TIFFErrorHandler warn = TIFFSetWarningHandler(0);
	
	  TIFF* tiff = TIFFOpen(filename, "r");
	
	  // turn warnings back on, just in case
	  TIFFSetWarningHandler(warn);
	
	  if (tiff) {
	    int rc = 1;			// what to return
	    uint32 w, h;
	    size_t npixels;
	    uint32* raster;
	
	    TIFFGetField(tiff, TIFFTAG_IMAGEWIDTH, &w);
	    TIFFGetField(tiff, TIFFTAG_IMAGELENGTH, &h);
	
	    // in case my data structures are different
	    rw = w;
	    rh = h;
	
	    npixels = w * h;
	    raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32));
	    if (raster != NULL) {
	      if (TIFFReadRGBAImage(tiff, w, h, raster, 0)) {
		rbits = (unsigned char*) raster;
	      } else {
		rc=0;
		_TIFFfree(raster);
	      }
	    } else rc = 0;
	
	    TIFFClose(tiff);
	    return rc;
	  } else
	    return 0;
}

void timecb(void* v) {
	static float timeLeft = 20.0f;
	timeLeft--;
	cout << "Time Left: " << timeLeft << endl;
	char buf[32];
	sprintf(buf,"Time Left: %.2f",timeLeft);
	buttonStart->copy_label(buf);
	fltk::repeat_timeout(60.0f,timecb);
}

ScanView::ScanView(int x,int y,int w,int h,const char* l) : fltk::Widget(x,y,w,h,l) {
	for (int i=0;i<181;i++)
		ranges[i] = 0.0f;
}

void ScanView::draw() {
	int resolution = 5;
	float x,y,scale;
	x = (float)w()/2.0f;
	y = (float)h()*3.0f/4.0f;
	scale = 13.0f;
	fltk::setcolor(fltk::WHITE);
	fltk::fillrect(0,0,w(),h());
	fltk::setcolor(fltk::BLACK);
	for (int i=0;i<181;i+=resolution)
	{
	fltk::drawline(x,y,x+cos(i*M_PI/180.0f)*ranges[i]*scale,y-sin(i*M_PI/180.0f)*ranges[i]*scale);
	}
}

void ScanView::pushLaserRanges(float* pRanges) {
	memcpy(ranges,pRanges,sizeof(float)*181);
	redraw();
}

MapView::MapView(int x,int y,int w,int h,const char* l) : fltk::Widget(x,y,w,h,l) {
	img = NULL;
	scale = 1.0f;
	upperLeftX = upperLeftY = 0.0f;
	iw = ih = 1;
	strcpy(filename,"map.tif");
	reload();
	currX = currY = 0.0f;
}

void MapView::draw() {
	if (img)
	img->draw(fltk::Rectangle(0,0,w(),h()));
	fltk::setcolor(fltk::RED);
	fltk::translate(currX,currY);
	fltk::push_matrix();
	fltk::rotate(-currTheta);
	fltk::scale(5.0f);
	fltk::drawline(0.0f,0.0f,1.0f,0.0f);
	fltk::drawline(0.0f,-.5f,0.0f,.5f);
	fltk::pop_matrix();
	//fltk::push_matrix();
	/*
	fltk::scale(15.0f);
	fltk::translate((int)currX,(int)currY);
	fltk::newpath();
	fltk::addvertex(-1,0);
	fltk::addvertex(1,0);
	fltk::addarc(-1.0f,-1.0f,1.0f,1.0f,-90.0f,90.0f);
	fltk::strokepath();
	//fltk::pop_matrix();
	*/
	
	//fltk::drawline((int)currX-5,(int)currY-5,(int)currX+5,(int)currY+5);
	//fltk::drawline((int)currX-5,(int)currY+5,(int)currX+5,(int)currY-5);
	/*
	fltk::push_matrix();
	fltk::rotate(currTheta);
	fltk::translate(currX,currY);
	fltk::addvertex(0,0);
	fltk::addvertex(5,0);
	fltk::fillstrokepath(fltk::RED);
	fltk::pop_matrix();
	*/
}

void MapView::reload() {
	unsigned char* buf;
	if (readTiff(filename,iw,ih,buf))
	{
	if (img) delete img;
	unsigned char* tmp = (unsigned char *)new char[iw*ih*4];
	memset(tmp,0,iw*ih*4);
	for (int h=0;h<ih;h++)
		memcpy(tmp+((ih-h-1)*iw*4),buf+(h*iw*4),iw*4);
	//img = new fltk::Image(buf,fltk::RGB32,tw,th);
	img = new fltk::Image(tmp,fltk::RGBA,iw,ih);
	delete tmp;
	delete buf;
	}
}

void MapView::setFilename(char* s) {
	strcpy(filename,s);
	reload();
}

int MapView::handle(int ev) {
	char buf[64];
	switch (ev)
	{
	case fltk::MOVE:
	if (iw != 1 && ih != 1)
	{
	float mx = (float)fltk::event_x()/(float)w() * iw * scale;
	float my = (1.0f-(float)fltk::event_y()/(float)h()) * ih * scale;
	xpos->value(upperLeftX+my);
	ypos->value(upperLeftY+mx);
	//xpos->value(upperLeftX+scale*((float)-iw)*((float)fltk::event_x()/(float)w()));
	//ypos->value(-upperLeftY-(scale*(float)ih)*(1.0f-(float)fltk::event_y()/(float)h()) );
	//ypos->value(upperLeftY+scale*((float)ih*((float)fltk::event_y()/(float)h())));
	}
	else
	{
	xpos->value(fltk::event_x());
	ypos->value(fltk::event_y());
	}
	return 1;
	case fltk::PUSH:
	sprintf(buf,"victim%i,%.2f,%.2f,0.0,VISUAL",currVictimID,xpos->value(),ypos->value());
	victimFileLine->text(buf);
	return 1;
	}
	
	return fltk::Widget::handle(ev);
}

void MapView::loadTFW(char* s) {
	float tmp;
	ifstream is(s);
	if (is.good())
	{
	is >> scale;
	is >> tmp;
	is >> tmp;
	is >> tmp;
	is >> upperLeftY;
	is >> upperLeftX;
	is.close();
	}
	else
	{
	scale = 1.0f;
	upperLeftX = 0.0f;
	upperLeftY = 0.0f;
	}
}

CameraView::CameraView(int x,int y,int w,int h,const char* l) : fltk::Widget(x,y,w,h,l) {
	base->imgMutex.lock();
	img = fltk::SharedImage::get("img.jpg");
	base->imgMutex.unlock();
	add_timeout(.25f);
}

void CameraView::draw() {
	if (base->imgMutex.trylock())
	{
	if (img)
	{
	img->reload();
	img->draw(fltk::Rectangle(5,5,w()-5,h()-5));
	}
	else
	{
	img = fltk::SharedImage::get("img.jpg");
	}
	base->imgMutex.unlock();
	}
}

int CameraView::handle(int ev) {
	switch (ev)
	{
	case fltk::TIMEOUT:
	//redraw();
	//fltk::check();
	//repeat_timeout(.1f);
	return 1;
	}
	//return fltk::Widget::handle(ev);
	return 1;
}

inline void BaseStationGUI::cb_Quit_i(fltk::Button*, void*) {
	Stop();
}
void BaseStationGUI::cb_Quit(fltk::Button* o, void* v) {
	((BaseStationGUI*)(o->parent()->parent()->parent()->user_data()))->cb_Quit_i(o,v);
}

inline void BaseStationGUI::cb_Screenshot_i(fltk::Button*, void*) {
	cout << "Screenshot #" << currVictimID << " taken!" << endl;
	ofstream in("img.jpg",ios::binary | ios::in);
	char s[32];
	sprintf(s,"victim%i.jpg",currVictimID);
	ofstream out(s,ios::binary | ios::out);
	out << in.rdbuf();
	in.close();
	out.close();
	out.open("victims.txt",ios::app);
	out << victimFileLine->text() << endl;
	out.close();
	sprintf(s,"Victim #%i",currVictimID);
	victimFileLine->text();
	currVictimID++;
}
void BaseStationGUI::cb_Screenshot(fltk::Button* o, void* v) {
	((BaseStationGUI*)(o->parent()->parent()->parent()->user_data()))->cb_Screenshot_i(o,v);
}

inline void BaseStationGUI::cb_bStart_i(fltk::Button*, void*) {
	base->start();
	//fltk::add_timeout(1.0f,timecb);
}
void BaseStationGUI::cb_bStart(fltk::Button* o, void* v) {
	((BaseStationGUI*)(o->parent()->parent()->parent()->user_data()))->cb_bStart_i(o,v);
}

BaseStationGUI::BaseStationGUI(BaseStation* b) {
	base = b;
	base->setGUI(this);
	fltk::register_images();
	currVictimID = 0;
	ofstream os("victims.txt");
	os.close();
}

void BaseStationGUI::Start() {
	fltk::Window* w;
	 {fltk::Window* o = win = new fltk::Window(1065, 865, "Base Station");
		w = o;
		o->shortcut(0xff1b);
		o->user_data((void*)(this));
		o->begin();
		 {CameraView* o = cameraView = new CameraView(310, 30, 745, 505, "Camera View");
			o->box(fltk::EMBOSSED_BOX);
			o->align(fltk::ALIGN_TOP);
		}
		 {MapView* o = mapView = new MapView(305, 550, 375, 309, "Map View");
			o->box(fltk::EMBOSSED_BOX);
			o->align(fltk::ALIGN_TOP);
			mapView->setFilename("map.tif");
			mapView->loadTFW("map.tfw");
		}
		 {MapView* o = aprioriView = new MapView(685, 550, 375, 309, "Apriori View");
			o->box(fltk::EMBOSSED_BOX);
			o->align(fltk::ALIGN_TOP);
			aprioriView->setFilename("apriori.tif");
			aprioriView->loadTFW("apriori.tfw");
		}
		 {ScanView* o = scanView = new ScanView(10, 675, 290, 185, "Laser Scan View");
			o->box(fltk::EMBOSSED_BOX);
			o->align(fltk::ALIGN_TOP);
		}
		 {fltk::ValueOutput* o = oxOutput = new fltk::ValueOutput(50, 565, 65, 25, "X");
			o->linesize(1.20259e+09);
			o->align(fltk::ALIGN_TOP);
		}
		 {fltk::ValueOutput* o = xp = new fltk::ValueOutput(50, 515, 65, 25, "GeoPos X");
			o->linesize(0.02);
			o->align(fltk::ALIGN_TOP);
			xpos = xp;
		}
		 {fltk::ValueOutput* o = yp = new fltk::ValueOutput(125, 515, 65, 25, "GeoPosY");
			o->linesize(1.20259e+09);
			o->align(fltk::ALIGN_TOP|fltk::ALIGN_LEFT);
			ypos = yp;
		}
		 {fltk::TabGroup* o = new fltk::TabGroup(10, 10, 290, 450);
			o->set_vertical();
			o->begin();
			 {fltk::Group* o = new fltk::Group(0, 20, 290, 430, "Main");
				o->set_vertical();
				o->begin();
				 {fltk::Button* o = new fltk::Button(65, 105, 160, 65, "Quit");
					o->callback((fltk::Callback*)cb_Quit);
				}
				 {fltk::Button* o = new fltk::Button(65, 190, 160, 65, "Screenshot");
					o->callback((fltk::Callback*)cb_Screenshot);
				}
				 {fltk::Button* o = bStart = new fltk::Button(65, 20, 160, 65, "Start");
					o->callback((fltk::Callback*)cb_bStart);
					buttonStart = bStart;
				}
				 {fltk::ProgressBar* o = signalStrength = new fltk::ProgressBar(28, 370, 225, 25, "Signal Strength");
					o->align(fltk::ALIGN_TOP|fltk::ALIGN_LEFT);
					signalStrength->showtext(true);
					signalStrength->range(61.64,90.0);
				}
				 {fltk::Output* o = vFileLine = new fltk::Output(30, 305, 225, 25, "Victim Data Line");
					o->align(fltk::ALIGN_TOP|fltk::ALIGN_LEFT);
					victimFileLine = vFileLine;
				}
				o->end();
			}
			o->end();
		}
		 {fltk::ValueOutput* o = othetaOutput = new fltk::ValueOutput(195, 565, 65, 25, "Theta");
			o->linesize(5.15899e+08);
			o->align(fltk::ALIGN_TOP);
		}
		 {fltk::ValueOutput* o = oyOutput = new fltk::ValueOutput(125, 565, 65, 25, "Y");
			o->linesize(5.15899e+08);
			o->align(fltk::ALIGN_TOP);
		}
		 {fltk::ValueInput* o = geoxInput = new fltk::ValueInput(50, 620, 65, 25, "X");
			o->align(fltk::ALIGN_TOP);
			geoxInput->value(9.58);
		}
		 {fltk::ValueInput* o = geoyInput = new fltk::ValueInput(125, 620, 65, 25, "Y");
			o->align(fltk::ALIGN_TOP);
			geoyInput->value(-20.95);
		}
		 {fltk::ValueInput* o = geothetaInput = new fltk::ValueInput(195, 620, 65, 25, "Theta");
			o->align(fltk::ALIGN_TOP);
			geothetaInput->value(0.0);
		}
		o->end();
		win->show();
		o->resizable(o);
	}
	std::cout << "BaseStationGUI::Start()" << std::endl;
}

void BaseStationGUI::Execute() {
	std::cout << "BaseStationGUI::Execute()" << std::endl;
	fltk::run();
}

void BaseStationGUI::Exit() {
	std::cout << "BaseStationGUI::Exit()" << std::endl;
}

void BaseStationGUI::Stop() {
	win->hide();
}

void BaseStationGUI::redraw() {
}

void BaseStationGUI::pushOdoPoint(float ox,float oy,float otheta) {
	oxOutput->value(ox);
	oyOutput->value(oy);
	othetaOutput->value(otheta);
	xp->value(geoxInput->value() + ox);
	yp->value(geoyInput->value() + oy);
	
	/*
	float mx = (float)fltk::event_x()/(float)w() * iw * scale;
	float my = (1.0f-(float)fltk::event_y()/(float)h()) * ih * scale;
	xpos->value(upperLeftX+my);
	ypos->value(upperLeftY+mx);
	*/
	
	MapView* mv = aprioriView;
	mv->currX = mv->w()/2;
	mv->currY = mv->h()/2;
	mv->currTheta = (geothetaInput->value() + otheta)/M_PI*180.0f - 90.0f;
	mv->redraw();
	//mv->currX = ((geoyInput->value()+0.0f)-mv->upperLeftY) / (mv->iw*mv->scale) * mv->w();
	//mv->currY = ((geoxInput->value()+0.0f)-mv->upperLeftX) / (mv->ih*mv->scale) * mv->h();
	//mv->currX = ((geoyInput->value()+oy)-mv->upperLeftY) / (mv->iw*mv->scale) * mv->w();
	//mv->currY = ((geoxInput->value()+ox)-mv->upperLeftX) / (mv->ih*mv->scale) * mv->h();
	//mv->currX = (geoyInput->value() + oy - mv->upperLeftY) / (mv->ih * mv->scale) * mv->w();
	//mv->currY = (geoxInput->value() - ox - mv->upperLeftX) / (mv->iw * mv->scale) * mv->h();
	
	//mv->redraw();
	/*
	//cout << "aprioriView cx,cy: " << mv->currX << " " << mv->currY << endl;
	mv = mapView;
	mv->currX = (geoyInput->value() + oy - mv->upperLeftY) / (mv->ih * mv->scale) * mv->w();
	mv->currY = (geoxInput->value() - ox - mv->upperLeftX) / (mv->iw * mv->scale) * mv->h();
	mv->setFilename("map.tif");
	mv->redraw();
	//cout << "mapView cx,cy: " << mv->currX << " " << mv->currY << endl;
	*/
}
