#include "Connection.h"
#include "ConnectionManager.h"

using namespace std;

ConnectionManager::ConnectionManager(char* name,char* ip,char* port,bool bConnectToUT)
{
    strcpy(hName,name);strcpy(hIP,ip);strcpy(hPort,port);
    char sPort[16];
    itoa(atoi(port)+1,sPort);
    conSend = new Connection(UT_IP_ADDR,UT_WCS_PORT,hName,sPort,hIP);
    conRecv = new Connection(UT_IP_ADDR,UT_WCS_PORT,hName,hPort,hIP);
    bUT = bConnectToUT;
}

bool ConnectionManager::SendHandShake(char* name,char* port)
{
    cout << "ConnectionManager::SendHandShake: from " << hName << " to " << name << " on port " << port << endl;
    strcpy(connectedTo,name);
    bool ret = false;
    if (!bUT)
        ret = conSend->connectNoUT(port);
    else
        ret = conSend->connect(name,port);
    return ret;
}

bool ConnectionManager::WaitForHandShake()
{
    cout << "ConnectionManager::WaitForHandShake: listening on " << hPort << endl;
    bool ret = false;
    if (!bUT)
        ret = conRecv->listenNoUT();
    else
        ret = conRecv->listen();
    return ret;
}

void ConnectionManager::Close()
{
    conSend->close(true);
    conRecv->close();
}

float ConnectionManager::getSS()
{
    static float r = -(70+rand()%20);
    if (bUT)
        return conSend->getSS(connectedTo);
    else
    {
        r -= 1.0f;
        if (r < -90.0)
            r = -70.0f;
        return r;
    }
}

void ConnectionManager::Send(Packet* p)
{
    if (bUT)
        conSend->send(p,true);
    else
    {
        conSend->send(p,false);
        usleep(500000);
    }

}

Packet* ConnectionManager::Receive()
{
    return conRecv->recv();
}

void ConnectionManager::Setup()
{
    cout << "ConnectionManager::Setup" << endl;
}

void ConnectionManager::Execute()
{
    cout << "ConnectionManager::Execute()" << endl;
}

void ConnectionManager::Exit()
{
    cout << "ConnectionManager::Exit" << endl;
}
