#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Packet.h"

Packet::Packet()
{
    type = size = 0;
    data = NULL;
}

Packet::Packet(int pType,int pSize)
{
    type = pType;
    size = pSize;
    data = (char *)malloc(size *  sizeof(char));
    memset(data,0,size * sizeof(char));
}

Packet::Packet(int pType,int pSize,char* pData)
{
    create(pType,pSize,pData);
}

Packet::Packet(Packet* p)
{
    create(p->type,p->size,p->data);
}

Packet::~Packet()
{
}

void Packet::create(int pType,int pSize,char* pData)
{
    type = pType;
    size = pSize;
    data = (char *)malloc(size * sizeof(char)+5);
    memcpy(data,pData,size * sizeof(char));
}

void Packet::destroy()
{
    if (data != NULL)
    {
        printf("Packet::destroy\n");
        //printf("%s\n",data);
        free(data);
        data = NULL;
    }
}

void Packet::packHeader(char* buf)
{
    char t[5];
    if (type==MSG) strcpy(t,"MSG");
    if (type==IMG) strcpy(t,"IMG");
    if (type==CMD) strcpy(t,"CMD");
    sprintf(buf,"%s %i",t,size);
}

int Packet::packData(char* buf,int pos,int blockSize)
{
    memset(buf,0,blockSize * sizeof(char));
    if ((pos + blockSize) <= size)
    {
        memcpy(buf,data + pos,(blockSize) * sizeof(char));
        return blockSize;
    }

    memcpy(buf,data + pos,(size - pos) * sizeof(char));
    return (size - pos);
}

void Packet::operator=(const Packet& p)
{
    type = p.type;
    size = p.size;
    if (data)
        free(data);
    data = (char *)malloc(size);
    memcpy(data,p.data,size);
}
