#include "Slam.h"

using namespace std;

Slam::Slam(bool bGT)
{
    currLine = 1;
    continueSlam = 1;
    log.open("map.log",ios::out);
    log.close();
}

void Slam::push(char* sData)
{
    cout << "Slam::push()::pushing data into map Q" << endl;
 
    dataMutex.lock();
    char *c,*d;
    char buf[32];
    memset((void *)&currOdo,0,sizeof(currOdo));
    memset((void *)&currSense,0,sizeof(currSense));

    log.open("map.log",ios::app);
    log << sData << endl;
    log.close();

    c = sData;
    while (strstr(c,"Odometry"))
        c+=strlen("Odometry");
    c-=strlen("Odometry");
    //cout << c << endl;

    //c = sData;
    //while (*c != 0)
    //{
        if (strstr(c,"Odometry") != 0 || strstr(c,"Laser") != 0)
        {
            //sscanf(c,"%s %.2f %.2f %.2f",buf,&currOdo.x,&currOdo.y,&currOdo.theta);
            c = strstr(c,"Odometry");
            c = strstr(c," "); *c = 0;
            d = c+1; c = strstr(d," "); *c = 0; currOdo.x = atof(d);
            d = c+1; c = strstr(d," "); *c = 0; currOdo.y = atof(d);
            d = c+1; c = strstr(d,"\n"); *c = 0; currOdo.theta = atof(d);
            c++;
            while (currOdo.theta > M_PI)    currOdo.theta -= 2*M_PI;
            while (currOdo.theta < -M_PI)   currOdo.theta += 2*M_PI;
            //cout << currOdo.x << " " << currOdo.y << " " << currOdo.theta << endl;
            //cout << "c:" << c << endl;
            //c = strstr(c,"Laser");
            c = strstr(c," "); *c = 0;

            d = c+1;
            //cout << "d: " << d << endl;;
            c = strstr(d," ");
            *c = 0;
            //cout << "c: " << c << endl;;
            int count = atoi(d);
            //cout << count << endl;

            for (int i=0;i<count-1;i++)
            {
                d = c+1;
                c = strstr(d," ");
                *c = 0;
                currSense.s[i].distance = atof(d);
                //cout << currSense.s[i].distance << " ";
            }
            //cout << endl;
            d = c+1;
            currSense.s[count-1].distance = atof(d);
            c++;
        }
        //else
        //    break;
    //}
    //*/
    dataMutex.unlock();
}

void Slam::GetOdometry(TOdo& o)
{
    dataMutex.lock();
    o.x = currOdo.x;
    o.y = currOdo.y;
    o.theta = currOdo.theta;
    //*
    ifstream is("map.log");
    char buf[32];int i=0;
    do
    {
        is >> buf;
        if (strcmp(buf,"Odometry")==0)
        {
            if (++i >= currLine)
            {
                //is >> currOdo.x >> currOdo.y >> currOdo.theta;
                cout << "got odometry line" << endl;
                is >> o.x >> o.y >> o.theta;
                break;
            }
        }
    } while (!is.eof());

    //if (is.eof())
    //    cout << "Reached end of logfile..." << endl;
    
    is.close();
    //*/
    dataMutex.unlock();
}

void Slam::GetSensation(TSense& s)
{
    dataMutex.lock();
    for (int i=0;i<181;i++)
        s[i].distance = currSense.s[i].distance*MAP_SCALE;
    //*
    ifstream is("map.log");
    char buf[32];int i=0;
    do
    {
        is >> buf;
        if (strcmp(buf,"Laser")==0)
        {
            if (++i >= currLine)
            {
                int count=0;
                is >> count;
                for (i=0;i<count;i++)
                {
                    double tmp;
                    is >> tmp;
                    s[i].distance = tmp*MAP_SCALE;
                }
                cout << "got laser line" << endl;
                currLine++;
                break;
            }
        }
    } while (!is.eof());
    
    //if (is.eof())
    //    cout << "Reached end of logfile..." << endl;
    
    is.close();
    //*/
    dataMutex.unlock();
}

void Slam::CurrOdometry(TOdo& o)
{
    dataMutex.lock();
    o.x = currOdo.x;
    o.y = currOdo.y;
    o.theta = currOdo.theta;
    dataMutex.unlock();
}

void Slam::CurrSensation(TSense& s)
{
    dataMutex.lock();
    for (int i=0;i<181;i++)
        s[i].distance = currSense.s[i].distance*MAP_SCALE;
    dataMutex.unlock();
}

void Slam::Setup()
{
    cout << "Slam::Setup" << endl;
    RECORDING = "";
    PLAYBACK = "";
    seedMT(1);
    InitLowSlam();
    InitHighSlam();
}

/*
   void GetOdometry(TOdo& odometry)
   {
}

void GetSensation(TSense& sense)
{
}
//*/

void Slam::Execute()
{
    cout << "Slam::Execute" << endl;

    TPath *path,*trashPath;
    TSenseLog *obs,*trashObs;
    path = trashPath = NULL;
    obs = trashObs = NULL;

    while (continueSlam && !bKill)
    {
        LowSlam(continueSlam,&path,&obs);
        HighSlam(path,obs);

        while (path != NULL)
        {
            trashPath = path;
            path = path->next;
            free(trashPath);
        }
        while (obs != NULL)
        {
            trashObs = obs;
            obs = obs->next;
            free(trashObs);
        }
    }
}

void Slam::Exit()
{
    cout << "Slam::Exit" << endl;
    CloseLowSlam();
}
