#include "Talon.h"

//#define CONNECT_TO_USARSIM false
extern bool bUT;

using namespace std;

Talon::Talon()
{
    cout << "Talon::Talon" << endl;
  
    bOK = false;
    if (bUT)
    {
        bIS = true;
        connectionManager   = new ConnectionManager(TALON_NAME,LOCAL_IP_ADDR,"7780",true);
        proxyManager        = new ProxyManager(PLAYER_IP_ADDR,PLAYER_PORT);
    }
    else
    {
        bIS = false;
        connectionManager   = new ConnectionManager(TALON_NAME,"localhost","7780",false);
        proxyManager        = new ProxyManager(PLAYER_IP_ADDR,PLAYER_PORT);
    }
    if (bIS)
        is = new ImgSrv(UT_IP_ADDR,UT_IMG_PORT);
}

void Talon::Setup()
{
    cout << "Talon::Setup" << endl;
    bOK = false;
    if (connectionManager->WaitForHandShake())
    {
        sleep(2);
        if (connectionManager->SendHandShake(BASESTATION_NAME,"7778"))
            bOK = true;
    }
}

void Talon::Execute()
{
    cout << "Talon::Execute" << endl;
    
    if (!bOK)
        return;

    Packet* cp = NULL;
    Packet* p  = NULL;

    int counter=0;
    while (!bKill)
    {
        cp = p = NULL;
        p = connectionManager->Receive();
        if (p==NULL)
        {
            cout << "null packet p!" << endl;
            break;
        }
        if (p->type==MSG)
        {
            cout << "got MSG: " << p->data << endl;
        }
        else if (p->type==CMD)
        {
            if (strstr(p->data,"START"))
            {
                cout << "got CMD to START" << endl;
                if (bOK)
                {
                    proxyManager->Start();
                    if (bIS) is->Start();
                }
                sleep(2);
            }
            else if (strstr(p->data,"STOP"))
            {
                break;
            }
            else if (strstr(p->data,"MOVE"))
            {
                int currLink = -1;
                float armSpeeds[5];
                for (int i=0;i<5;i++)
                    armSpeeds[i] = 0.0f;

                cout << "got "<< p->data << endl;
                char* c = strstr(p->data," ");
                *c = 0;
                char* sSpeed = c+1;
                c = strstr(sSpeed," ");
                *c = 0;
                char* sRot = c+1;
                c = strstr(sRot," ");
                *c = 0;

                for (int i=0;i<5;i++)
                {
                    char* speed = c+1;
                    c = strstr(speed," ");
                    if (i==4)
                        c = strstr(speed,":");
                    *c = 0;
                    armSpeeds[i] = atof(speed);
                }

                proxyManager->move(atof(sSpeed),atof(sRot),5,armSpeeds);
            }
        }

        if (++counter >= 1000)
            counter = 0;

        if (counter%2 != 0)
        {
            cout << "sent DATA" << endl;
            p = proxyManager->front();
            if (p)
                connectionManager->Send(p);
            proxyManager->pop_front();
        }
        else
        {
            cout << "sent IMG" << endl;
            if (bIS)
            {
                cp = is->front();
                if (cp != NULL)
                    connectionManager->Send(cp);
                is->pop_front();
                if (cp==NULL)
                {
                    char z[32];
                    sprintf(z,"No Image Yet...");
                    p = new Packet(MSG,strlen(z)+1,z);
                    connectionManager->Send(p);
                    delete p;
                    p = NULL;
                }
                is->Resume();
            }
            else
            {
                static int imageNum=0;
                char z[32];

                if (++imageNum >= 100)
                    imageNum = 0;

                sprintf(z,"img%i.jpg",imageNum%10);
                FILE* f = fopen(z,"rb");
                gdImagePtr img = gdImageCreateFromJpeg(f);
                fclose(f);
                int s = 0;
                char* buf = (char *)gdImageJpegPtr(img,&s,50);
                p = new Packet(IMG,s,buf);
                connectionManager->Send(p);
                gdImageDestroy(img);
                delete p;
                p = NULL;
            }
        }
    }
}

void Talon::Exit()
{
    cout << "Talon::Exit" << endl;
    connectionManager->Close();
    if (bOK)
    {
        proxyManager->Stop();
        if (bIS) is->Stop();
    }
}
